	.include "forth.inc"

	.set _bctrl, 0x4e800421
	.set _mtctr_tos, (0x7c0903a6|(tos<<21))
	.set _mflr_r0, 0x7c0802a6
	.set _mtlr_r0, 0x7c0803a6
	.set _rpush_r0, (0x9400fffc|(rs<<16))
	.set _rfetch_r0, (0x80000000|(rs<<16))
	.set _rdrop, (0x38200004|(rs<<16))
	.set _blr, 0x4e800020
	.set _dup, (0x9400fffc|(tos<<21)|(ds<<16))
	.set _lis_tos, (0x3c000000|(tos<<21))
	.set _ori_tos, (0x60000000|(tos<<21)|(tos<<16))
	.set _li_tos, (0x38000000|(tos<<21))
	.set _lwz_tos, (0x80000000|(tos<<21)|(ds<<16))
	.set _addi_ds_4, (0x38000004|(ds<<21)|(ds<<16))
	.set _beq, 0x41820000
	.set _bne, 0x40820000
	.set _b, 0x48000000
	.set _bdnz, 0x42000000
	.set _cmpwi_tos, (0x2c000000|(tos<<16))

	.macro li_rpop_r0 i1,i2
	lis \i1,_rfetch_r0@h
	liwl \i2,_rdrop
	.endm

	.macro li_bl instr,offset
	rlwinm \offset,\offset,0,6,29
	liwl \instr,0x48000001
	or \instr,\instr,\offset
	.endm

	.macro li_lis_tos i,n
	srwi \i,tos,16
	oris \i,\i,_lis_tos@h
	.endm

	.macro li_ori_tos i,n
	clrlwi \i,tos,16
	oris \i,\i,_ori_tos@h
	.endm

	.macro li_liwl_tos i1,i2,n
	li_lis_tos \i1,\n
	li_ori_tos \i2,\n
	.endm

	.macro li_li_tos i,n
	clrlwi \i,\n,16
	oris \i,\i,_li_tos@h
	.endm

	.macro li_drop i1,i2
	lis \i1,_lwz_tos@h  #low 16 are 0
	liwl \i2,_addi_ds_4
	.endm
