: _rs 0 ;
: _ds 13 ;
: _tos 14 ;
: _here 15 ;
: _a 16 ;
: _toc 31 ;

compiler
: dup [ _tos _ds -4 _stwu ]l , ;
: drop [ _tos _ds 0 _lwz ]l , [ _ds _ds 4 _addi ]l , ;
: trap [ _trap ]l , ;
forth
: trap [ _trap , ] ;

\ asm utility words
: reg> postpone dup _tos swap _mr , ;
: >reg _tos _mr , postpone drop ;
: >toc [ _toc >reg ] ;
: toc> [ _toc reg> ] ;

: _push postpone dup [ _tos _rs 0 _lwz ]l , [ _rs _rs 4 _addi ]l , ;
: _pop [ _tos _rs -4 _stwu ]l , postpone drop ;

\ variables
: args dup [ _tos _toc -4 _addi , ] ;
: var_here dup [ _tos _toc -8 _addi , ] ;
: state dup [ _tos _toc -12 _addi , ] ;
: flushed_to dup [ _tos _toc -16 _addi , ] ;
: ffree dup [ _tos _toc -20 _addi , ] ;
: fdict dup [ _tos _toc -24 _addi , ] ;
: cfree dup [ _tos _toc -28 _addi , ] ;
: cdict dup [ _tos _toc -32 _addi , ] ;
: cur-dict dup [ _tos _toc -36 _addi , ] ;


: 0< [ _tos 0 _cmpi ]l , [ _tos -1 _li ]l , [ _bltlr ]l , [ _tos 0 _li ]l , ;

: _0= [ _tos 0 _cmpi ]l , postpone drop ;
compiler : until _0= here - _beq , ; forth

: h@a dup [ _tos _a 0 _lhz , ] ;
: h!a [ _tos _a 0 _sth , ] drop ;
: h@ a! h@a ;
: h! a! h!a ;
